APT-GET(8)

NAME
apt-get - Utilitaire d'APT pour la manipulation de paquets -- interface en ligne de commande.

SYNOPSIS
apt-get [ -hvs ] [ -o=option de configuration ] [ -c=fichier ] { update | upgrade | dselect-upgrade | install paquet ... | remove paquet ... | source paquet ... | build-dep paquet ... | check | clean | autoclean }

DESCRIPTION

apt-get est l'outil en ligne de commande pour manipuler les paquets. Il peut être considéré par l'utilisateur comme un générateur de sortie pour les autres outils de la bibliothèque APT.

À moins que l'option -h, ou --help ne soit donnée, l'une des commandes suivantes doit être présente.

update
    La commande update permet de resynchroniser un fichier répertoriant les paquets disponibles et sa source. Ces fichiers sont récupérés aux endroits spécifiés dans /etc/apt/sources.list. Ainsi, lorsqu'on utilise une archive Debian, cette commande récupère les fichiers Packages.gz et les analyse de manière à rendre disponibles les informations concernant les nouveaux paquets et les paquets mis à jour. On doit toujours exécuter une commande update avant les commandes upgrade ou dist-upgrade. Il faut savoir que l'indicateur de progression d'ensemble n'est pas correct puisque la taille de ces fichiers ne peut être connue à l'avance.

upgrade
    La commande upgrade permet d'installer les versions les plus récentes de tous les paquets présents sur le sytème en utilisant les sources énumérées dans /etc/apt/sources.list. Les paquets installés dont il existe de nouvelles versions sont récupérés et mis à niveau. En aucun cas des paquets déjà installés ne sont supprimés ; de même, des paquets qui ne sont pas déjà installés ne sont ni récupérés ni installés. Les paquets dont de nouvelles versions ne peuvent pas être installées sans changer le statut d'installation d'un autre paquet sont laissés dans leur version courante. On doit d'abord exécuter la commande update pour que apt-get connaisse l'existence de nouvelles versions des paquets.

dselect-upgrade
    dselect-upgrade est utilisée conjointement avec dselect(8), l'interface traditionnelle Debian pour la gestion des paquets. La commande dselect-upgrade suit les modifications faites par dselect(8) dans le champ Status des paquets disponibles, et effectue les actions nécessaires à la réalisation de cet état (par exemple, suppression d'anciens paquets, installation de nouveaux paquets).

dist-upgrade
    La commande dist-upgrade effectue la fonction upgrade en y ajoutant une gestion intelligente des changements de dépendances dans les nouvelles versions des paquets ; apt-get possède un système « intelligent » de résolution des conflits et il essaye, quand c'est nécessaire, de mettre à niveau les paquets les plus importants aux dépens des paquets les moins importants. Le fichier /etc/apt/sources.list contient une liste de sources où récupérer les paquets désirés. Voyez aussi apt_preferences(5) pour un mécanisme d'annulation des paramètres d'un simple paquet.

install
    La commande install est suivie par un ou plusieurs paquets à installer. Chaque paquet est un nom de paquet ; ce n'est pas un nom de fichier pleinement déterminé (par exemple, dans un système Debian GNU/Linux, on indiquera libc6 et non pas libc6_1.9.6-2.deb). Tous les paquets requis par le(s) paquet(s) que l'on veut installer sont aussi récupérés et installés. On se sert du fichier /etc/apt/sources.list pour localiser les paquets désirés. Quand un trait d'union est accolé (sans espace intermédiaire) au nom d'un paquet déjà installé, ce paquet est supprimé. De même on peut ajouter un signe « + » pour désigner un paquet à installer. Cette dernière fonctionnalité peut être utilisée pour annuler les décisions prises par le système de résolution des conflits d'apt-get. On peut choisir d'installer une version particulière d'un paquet en faisant suivre son nom par un signe égal et par la version. Cette version sera localisée et l'installation sera demandée. On peut aussi choisir une distribution particulière en faisant suivre le nom du paquet par une barre oblique et par le nom de la distribution ou de l'archive (stable, testing, unstable). Avec ces possibilités de choisir la version, de vieilles versions d'un paquet peuvent être installées. Il faut faire attention. Enfin, le mécanisme de apt_preferences(5) permet de créer d'autres règles pour l'installation des paquets. Quand aucun paquet ne correspond à l'expression donnée en argument et que cette expression contient l'un des caractères « . », « ? » ou « * », on considère que c'est une expression rationnelle POSIX et elle est appliquée à tous les paquets de la base de données. Tout paquet correspondant est installé (ou supprimé). Notez que la comparaison est effectuée par sous-chaîne et « lo » correspond aussi bien à « how-lo » qu'à « lowest ». Si vous ne le voulez pas, ancrez l'expression par un caractère « ^ » ou un caractère « $ », ou bien créez une expression plus précise.

remove
    La commande remove est identique à la commande install ; Mais les paquets sont supprimés et non pas installés. Quand un signe plus est accolé (sans espace intermédiaire) au nom du paquet, le paquet est installé au lieu d'être supprimé.

source
    Avec la commande source, apt-get récupère des paquets sources. APT examine les paquets disponibles pour choisir le paquet source à récupérer. Il trouve ensuite et télécharge dans le répertoire courant la version la plus récente. Les paquets source sont suivis différemment que les paquets binaires, via les lignes de type deb-src dans le fichier sources.list(5) . On n'obtiendra probablement pas les mêmes sources que celles du paquet installé ou celles du paquet qu'on pourrait installer. Si l'option --compile est spécifiée, le paquet est compilé en un binaire .deb avec dpkg-buildpackage. Si --download-only est spécifié, le source n'est pas décompacté. De la même façon qu'avec les paquets binaires, on peut récupérer une version particulière d'un paquet source en faisant suivre son nom par un signe égal et par la version. Cela permet une comparaison exacte entre le nom du paquet source et la version ; cela lance implicitement la commande APT::Get::Only-Source. Notez que les paquets sources ne sont pas suivis comme le sont les paquets binaires. Ils ne sont présents que dans le répertoire courant et sont semblables à des sources téléchargés sous forme de tarball.

build-dep
    Avec la commande build-dep, apt-get installe ou supprime des paquets dans le but de satisfaire les dépendances de construction d'un paquet source. Pour l'instant, dans la cas d'un paquet virtuel, un paquet est choisi au hasard.

check
    La commande check est un outil de diagnostic ; il met à jour le cache des paquets et cherche des dépendances défectueuses.

clean
    La commande clean nettoie le référentiel local des paquets récupérés. Il supprime tout, excepté le fichier lock situé dans /var/cache/apt/archives/ et /var/cache/apt/archives/partial/. Quand APT est utilisé comme mode de dselect(8), clean est effectué automatiquement. Quand on n'utilise pas dselect(8), il faut exécuter apt-get clean de temps en temps si l'on veut libérer de l'espace disque.

autoclean
    Tout comme clean, autoclean nettoie le référentiel local des paquets récupérés. La différence est qu'il supprime uniquement les paquets qui ne peuvent plus être téléchargés et qui sont grandement inutiles. On peut ainsi contrôler la taille de ce cache sur une longue période. Tant qu'elle n'est pas activée, l'option de configuration APT::Clean-Installed empêche la suppression de paquets installés.

OPTIONS

Toutes les options en ligne de commande peuvent être positionnées via le fichier de configuration ; les descriptifs indiquent l'option de configuration à positionner. En ce qui concerne les options booléennes, on peut annuler le fichier de configuration en utilisant quelque chose comme -f-,--no-f, -f=no ou d'autres variantes.

-d

--download-only
    Récupération seule ; les paquets sont ramenés mais ne sont ni dépaquetés ni installés. Élément de configuration : APT::Get::Download-Only.

-f

--fix-broken
    Correction ; essaye de réparer un système dont les dépendances sont défectueuses. Cette option, utilisée avec install ou remove, peut omettre tout paquet de façon à permettre à APT de déduire une solution viable. Chaque paquet spécifié doit complètement corriger le problème. Cette option est quelquefois nécessaire lorsque l'on exécute APT pour la première fois ; APT lui-même interdit les dépendances défectueuses dans un système. Il est possible que la structure de dépendances d'un système soit tellement corrompue qu'elle requiert une intervention manuelle (ce qui veut dire la plupart du temps utiliser dselect(8) ou dpkg --remove pour éliminer les paquets en cause). L'utilisation de cette option conjointement avec -m peut produire une erreur dans certaines situations. Élément de configuration : APT::Get::Fix-Broken.

-m

--ignore-missing

--fix-missing
    Ignorer les paquets manquants ; si des paquets ne peuvent être récupérés, ou, après récupération, ne satisfont pas au contrôle d'intégrité, cette commande met ces paquets de côté et gère le résultat. Utiliser cette option conjointement avec -f peut produire une erreur dans certaines situations. Quand un paquet, sélectionné pour une installation (particulièrement si c'est mentionné en ligne de commande), ne peut être récupéré, il est mis silencieusement de côté. Élément de configuration : APT::Get::Fix-Missing.

--no-download
    Pas de récupération. Le mieux est d'utiliser cette option avec --ignore-missing pour forcer APT à n'utiliser que les .deb qu'il a déjà récupérés. Élément de configuration : APT::Get::Download.

-q

--quiet
    Mode silencieux ; cette commande produit une sortie destinée à l'enregistrement dans un fichier-journal en omettant les indicateurs de progression. Un plus grand nombre de « q » (2 au plus) produit un plus grand silence. On peut aussi utiliser -q=# pour positionner le niveau de silence, et annuler le fichier de configuration. Notez qu'un niveau de silence égal à 2 implique -y et vous ne devez jamais utiliser -qq sans l'accompagner d'un modificateur tel que -d, --print-uris ou -s : APT pourrait exécuter des actions inattendues ! Élément de configuration : quiet.

-s

--simulate

--just-print

--dry-run

--recon

--no-act
    Simulation ; cette commande réalise une simulation des actions qui seraient exécutées mais ne modifie pas le système. Élément de configuration : APT::Get::Simulate. la simulation affiche une série de lignes représentant chacune une opération de dpkg, Configure (Conf),Remove (Remv),Unpack (Inst). Les crochets encadrent des paquets endommagés et des crochets n'encadrant rien indiquent que les dommages n'ont aucune conséquence (rare).

-y

--yes

--assume-yes
    Répond automatiquement oui aux questions ; présume « oui » comme réponse à toutes les questions et s'exécute de manière non interactive. Dans le cas d'une situation indésirable, comme le changement d'un paquet gelé ou la suppression d'un paquet essentiel, apt-get s'interrompt. Élément de configuration : APT::Get::Assume-Yes.

-u

--show-upgraded
    Afficher les paquets mis à niveau ; affiche une liste de tous les paquets à mettre à niveau. Élément de configuration : APT::Get::Show-Upgraded.

-V

--verbose-versions
    Afficher les versions complètes des paquets installés ou mis à niveau. Élément de configuration : APT::Get::Show-Versions.

-b

--compile

--build
    Cette commande compile un paquet source après l'avoir récupéré. Élément de configuration : APT::Get::Compile.

--ignore-hold
    Cette commande ignore la marque « Hold » d'un paquet ; par ce biais, apt-get ignore un « hold » placé sur un paquet. cela peut être utile avec dist-upgrade pour annuler un grand nombre de « hold » indésirables. Élément de configuration : APT::Ignore-Hold.

--no-upgrade
    Aucune mise à niveau ; quand elle est utilisée avec install, cette commande empêche les paquets listés sur la ligne de commande d'être mis à niveau. Élément de configuration : APT::Get::Upgrade.

--force-yes
    Forcer l'acceptation ; cette option est dangereuse parce qu'elle laisse APT continuer sans poser de questions quand il réalise quelque chose de potentiellement dommageable. Cette option ne doit être utilisée que dans des circonstances très spéciales. Utiliser force-yes peut détruire le système ! Élément de configuration : APT::Get::force-yes.

--print-uris
    Au lieu d'aller chercher les paquets à installer, leurs URI sont affichées. Chaque URI a un chemin, un nom de fichier destination, une taille et une clé md5 attendue. Notez que le nom de fichier à afficher ne correspond pas toujours au nom de fichier sur le site distant ! Cette option marche aussi avec la commande source. Élément de configuration : APT::Get::Print-URIs.

--purge
    Utiliser purge à la place de remove pour supprimer tout ce qui peut être supprimé. Un astérisque (*)sera affiché près des paquets qui vont être purgés. Élément de configuration : APT::Get::Purge.

--reinstall
    Réinstaller les paquets déjà installés avec leur version la plus récente. Élément de configuration : APT::Get::ReInstall.

--list-cleanup
    Cette option est activée par défaut ; utilisez --no-list-cleanup pour la désactiver. Quand elle est activée, apt-get gère automatiquement le contenu de /var/lib/apt/lists afin d'assurer que les fichiers obsolètes sont effacés. La seule raison de la désactiver est une modification fréquente de votre liste de sources. Élément de configuration : APT::Get::List-Cleanup.

-t

--target-release

--default-release
    Cette option contrôle l'entrée par défaut pour les questions de distribution ; une étiquette (pin) par défaut dont la priorité vaut 990 est créé en utilisant la chaîne spécifiée. Le fichier des préférences peut annuler cette décision. En clair, cette option permet de contrôler simplement dans quelle distribution seront récupérés les paquets. Par exemple : -t '2.1*' ou -t unstable. Élément de configuration : APT::Default-Release. Voyez aussi la page de manuel apt_preferences(5).

--trivial-only
    Ne réalise que les opérations « triviales ». Logiquement ceci peut être considéré comme relatif à --assume-yes. Alors que --assume-yes répond oui à n'importe quelle question, --trivial-only répond non. Élément de configuration : APT::Get::Trivial-Only.

--no-remove
    Quand des paquets doivent être supprimés, apt-get s'arrête immédiatement sans poser de questions. Élément de configuration : APT::Get::Remove.

--only-source
    Cette option n'a de sens qu'avec la commande source. Elle indique que les noms de sources donnés ne doivent pas être repérés à travers la table binaire. Cela signifie que si cette option est choisie, la commande source acceptera seulement des noms de paquets-source comme argument ; elle n'acceptera pas de les rechercher à partir des noms de paquets binaires correspondants. Élément de configuration : APT::Get::Only-Source

--diff-only

--tar-only
    Ne récupérer que le fichier diff ou tar d'une archive de source. Élément de configuration : APT::Get::Diff-Only et APT::Get::Tar-Only.

--arch-only
    Ne traiter que les dépendances de construction pour telle architecture. Élément de configuration : APT::Get::Arch-Only

-h

--help
    Affiche un mode d'emploi succinct.

-v

--version
    Affiche la version du programme.

-c

--config-file
    Fichier de configuration ; indique quel fichier de configuration utiliser. Le programme lit le fichier de configuration par défaut, puis celui-ci. Voyez apt.conf(5) pour la syntaxe.

-o

--option
    Donne une option de configuration ; cela fixe une option de configuration arbitraire. La syntaxe est : -o Foo::Bar=bar.

FICHIERS

/etc/apt/sources.list
    Liste les emplacements où aller chercher les paquets. Élément de configuration : Dir::Etc::SourceList.

/etc/apt/apt.conf
    Fichier de configuration d'APT. Élément de configuration : Dir::Etc::Main.

/etc/apt/apt.conf.d/
    Éléments du fichier de configuration d'APT. Élément de configuration : Dir::Etc::Parts.

/etc/apt/preferences
    Fichier des préférences. C'est dans ce fichier qu'on peut faire de l'étiquetage (pinning) c'est-à-dire, choisir d'obtenir des paquets d'une source distincte ou d'une distribution différente. Élément de configuration : Dir::Etc::Preferences.

/var/cache/apt/archives/
    Zone de stockage pour les paquets récupérés. Élément de configuration : Dir::Cache::Archives.

/var/cache/apt/archives/partial/
    Zone de stockage pour les paquets en transit. Élément de configuration : Dir::Cache::Archives (implicitement, partial).

/var/lib/apt/lists/
    Zone de stockage des informations concernant chaque ressource spécifiée dans sources.list(5) . Élément de configuration : Dir::State::Lists.

/var/lib/apt/lists/partial/
    Zone de stockage pour les informations d'état des paquets en transit. Élément de configuration : Dir::State::Lists (implicit partial).

VOIR AUSSI

apt-cache(8) , dpkg(8) , dselect(8), sources.list(5) , apt.conf(5) , apt-config(8), le guide « APT users guide » dans /usr/share/doc/apt/, apt_preferences(5), le APT Howto.

DIAGNOSTICS

apt-get retourne zéro après un déroulement normal, et le nombre décimal 100 en cas d'erreur.

BOGUES

Voyez la page concernant les bogues de APT <URL:http://bugs.debian.org/src:apt>. Si vous voulez rapporter un bogue, consultez le texte /usr/share/doc/debian/bug-reporting.txt ou utilisez la commande reportbug(1) .

AUTEUR

APT a été écrit par l'équipe APT <apt@packages.debian.org>.

TRADUCTION

Jérôme Marant. 2000 ; mise à jour : Philippe Batailler. 2004.